#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <getopt.h>

#include "ts.h"
#include "sdt.h"
#include "eit.h"

int main(int argc, char *argv[]) {

	FILE *infile = stdin;
	FILE *outfile = stdout;
	int   mode = 0;
	char *file;
	int   inclose = 0;
	int   outclose = 0;

	int rtn;

#define SECCOUNT 4

	SECcache   secs[SECCOUNT];
	SECcache  *bsecs;

	/* getoptexternѿ
	   optind = 0;
	   opterr = 0;
	   optopt = 0;
	   optarg = NULL;
	*/

	while((rtn = getopt(argc, argv, "l")) != -1) {
		switch(rtn) {
		case 'l':
			mode = 1;
			break;
		}
	}
  
	/* ³Υå */
	if(optind < argc) {
		/* ϥե̾ͭ */
		file = argv[optind++];
		/* -ʳʤopen */
		if(strcmp(file, "-")) {
			infile = fopen(file, "r");
			inclose = 1;
		}
	}

	if(optind < argc) {
		/* ϥե̾ͭ */
		file = argv[optind++];
		/* -ʳʤopen */
		if(strcmp(file, "-")) {
			outfile = fopen(file, "wb+");
			outclose = 1;
		}
	}

	/* ̣Τpid */
	memset(secs, 0,  sizeof(SECcache) * SECCOUNT);
	secs[0].pid = 0x11;
	secs[1].pid = 0x12;
	secs[2].pid = 0x26;
	secs[3].pid = 0x27;

	while((bsecs = readTS(infile, secs, SECCOUNT)) != NULL) {
		/* SDT */
		if((bsecs->pid & 0xFF) == 0x11) {
			dumpSDT(outfile, bsecs->buf, mode);
		}
		/* EIT */
		if((bsecs->pid & 0xFF) == 0x12) {
			dumpEIT(outfile, bsecs->buf, mode);
		}
		/* EIT */
		if((bsecs->pid & 0xFF) == 0x26) {
			dumpEIT(outfile, bsecs->buf, mode);
		}
		/* EIT */
		if((bsecs->pid & 0xFF) == 0x27) {
			dumpEIT(outfile, bsecs->buf, mode);
		}
	}

	if(inclose) {
		fclose(infile);
	}

	if(outclose) {
		fclose(outfile);
	}

	return 0;
}

